<template>
  <div>
    <ex-table
      v-loading="loading"
      :table="table"
      :data="tableData"
      :columns="table13"
      :page="pageInfo"
      :size="size"
      @page-curr-change="handlePageChange"
      @page-size-change="handleSizeChange"
      @screen-reset="
        pageInfo.curr = 1;
        parmValue.page = 1;
        searchList();
      "
      @screen-submit="
        pageInfo.curr = 1;
        parmValue.page = 1;
        searchList();
      "
      @selection="selection_change"
    >
      <template #table-header="{}">
        <div style="width: 100%">
          <el-row style="padding: 0 0 0 80px">
            <el-col :span="6" style="width: 463px">
              <periodDatePickerActive
                :start="parmValue.start_date"
                :end="parmValue.end_date"
                :placeholder="'产品操作'"
                :width="'205px'"
                :size="searchSize"
                @timeReturned="time"
              />
            </el-col>
            <el-col :span="4" style="width: 66px; float: right">
              <el-button
                type="primary"
                style="margin-left: 30px"
                :size="searchSize"
                class="fr"
                @click="download"
              >
                导出
              </el-button>
            </el-col>
            <el-col :span="3" style="width: 66px; float: right">
              <el-button
                :size="searchSize"
                type="primary"
                style="float: right; margin-left: 5px"
                @click="searchList"
              >
                刷新
              </el-button>
            </el-col>
          </el-row>
          <el-row style="padding: 10px 0 0 0" gutter="10">
            <el-col :span="6" style="width: 240px">
              <el-input
                v-model="parmValue.creater"
                clearable
                placeholder="采购维护人"
                maxlength="40"
                :size="searchSize"
                @blur="
                  pageInfo.curr = 1;
                  parmValue.page = 1;
                  searchList();
                "
              />
            </el-col>
            <el-col :span="6" style="width: 240px">
              <el-input
                v-model="parmValue.supplier_name"
                clearable
                placeholder="供应商名称"
                maxlength="40"
                :size="searchSize"
                @blur="
                  pageInfo.curr = 1;
                  parmValue.page = 1;
                  searchList();
                "
              />
            </el-col>
            <el-col :span="4" style="width: 66px; float: right">
              <el-button
                type="warning"
                class="fr"
                :size="searchSize"
                @click="restSearch"
              >
                重置
              </el-button>
            </el-col>
          </el-row>
        </div>
      </template>

      <template #operation="{ scope }">
        <el-tooltip effect="dark" content="修改内容对比" placement="top">
          <i class="el-icon-view tb-icon" @click="dlgTable(scope.row)" />
        </el-tooltip>
      </template>
    </ex-table>

    <el-dialog
      title="产品修改差异对比"
      :visible.sync="dialogTableVisible"
      :center="true"
      align="left"
      top="3vh"
      width="1040px"
      :close-on-click-modal="false"
      element-loading-text="拼命加载中"
      element-loading-spinner="el-icon-loading"
      element-loading-background="rgba(0, 0, 0, 0.8)"
      @close="dialogTableVisible = false"
    >
      <el-table
        :data="showData"
        :size="searchSize"
        border
        stripe
        max-height="750px"
        style="width: 100%; margin: -20px 0 0"
      >
        <el-table-column
          prop="key_name"
          label="修改字段名称"
          width="130px"
          show-overflow-tooltip
        />
        <el-table-column
          prop="key"
          label="修改字段"
          width="130px"
          show-overflow-tooltip
        />
        <el-table-column prop="before" label="修改前" show-overflow-tooltip>
          <template slot-scope="scope">
            <div v-if="scope.row.key === 'good_img'">
              <img
                v-for="(si, sii) in scope.row.before"
                :key="si + sii"
                v-viewer
                :src="si"
                alt=""
                class="fl"
                style="width: 30px; height: 30px"
              >
            </div>
            <div v-else-if="scope.row.key === 'good_info_img'">
              <img
                v-for="(si, sii) in scope.row.after"
                :key="si + sii"
                v-viewer
                :src="si"
                alt=""
                class="fl"
                style="width: 30px; height: 30px"
              >
            </div>
            <div v-else-if="scope.row.key === 'good_thumb_img'">
              <img
                v-for="(si, sii) in scope.row.after"
                :key="si + sii"
                v-viewer
                :src="si"
                alt=""
                class="fl"
                style="width: 30px; height: 30px"
              >
            </div>
            <div v-else>{{ scope.row.before }}</div>
          </template>
        </el-table-column>
        <el-table-column prop="after" label="修改后" show-overflow-tooltip>
          <template slot-scope="scope">
            <div v-if="scope.row.key === 'good_img'">
              <img
                v-for="(si, sii) in scope.row.after"
                :key="si + sii"
                v-viewer
                :src="si"
                alt=""
                class="fl"
                style="width: 30px; height: 30px"
              >
            </div>
            <div v-else-if="scope.row.key === 'good_info_img'">
              <img
                v-for="(si, sii) in scope.row.after"
                :key="si + sii"
                v-viewer
                :src="si"
                alt=""
                class="fl"
                style="width: 30px; height: 30px"
              >
            </div>
            <div v-else-if="scope.row.key === 'good_thumb_img'">
              <img
                v-for="(si, sii) in scope.row.after"
                :key="si + sii"
                v-viewer
                :src="si"
                alt=""
                class="fl"
                style="width: 30px; height: 30px"
              >
            </div>
            <div v-else>{{ scope.row.after }}</div>
          </template>
        </el-table-column>
      </el-table>
    </el-dialog>
  </div>
</template>
<script>
import mixinPage from '@/mixins/elPaginationHandle'
import resToken from '@/mixins/resToken'
import urlConfig from '@/apis/url-config'
import asyncRequest from '@/apis/service/businessReportQuery/purchaseReport'
import periodDatePickerActive from '../period-date-picker/main.vue'
import { table13, editTable13 } from './columns'
import { mapGetters } from 'vuex'
import companyHelper from '@/mixins/companyHelper'

export default {
  name: 'PurchaseOrder',
  components: {
    periodDatePickerActive
  },
  mixins: [mixinPage, resToken, companyHelper],
  computed: {
    ...mapGetters(['tablebtnSize', 'searchSize', 'size'])
  },
  data() {
    return {
      editOld: {},
      editNew: {},
      dialogTableVisible: false,
      // 选中数组
      changeList: [],
      showData: [],
      // 全局url
      fileUrl: urlConfig.baseURL,
      // loading
      loading: false,
      // 请求参数集合
      parmValue: {
        creater: '', // 采购维护人
        supplier_name: '', // 供应商名称
        start_date: '', // 起始时间
        end_date: '', // 结束时间
        page: 1, // 页码
        size: 15 // 每页显示条数
      },
      // 表格 - 数据集合
      tableData: [],
      // 表格 - 参数
      table: {
        stripe: true,
        border: true,
        _defaultHeader_: ['setcol']
      },
      // 表格 - 分页
      pageInfo: {
        size: 15,
        curr: 1,
        total: 0
      },

      table13: table13,
      editTable13
    }
  },
  mounted() {
    this.searchList()
  },

  methods: {
    dlgTable(row) {
      this.showData = []
      const { before_info, after_info } = row

      const keyList = []
      for (const key in after_info) {
        keyList.push(key)
      }

      for (let i = 0; i < keyList.length; i++) {
        const model = {
          key: keyList[i],
          key_name:
            (editTable13.find((s) => s.prop === keyList[i]) || {}).label ||
            '--',
          before: this.get_key_value(keyList[i], before_info),
          after: this.get_key_value(keyList[i], after_info)
        }
        // console.log(model.key_name)
        this.showData.push(model)
      }
      this.dialogTableVisible = true
    },
    get_key_value(key, info) {
      if (key === 'good_img') {
        return info[key] ? (info[key] || '').split(',') : []
      } else if (key === 'good_info_img') {
        return info[key] ? (info[key] || '').split(',') : []
      } else if (key === 'good_thumb_img') {
        return info[key] ? (info[key] || '').split(',') : []
      }
      // else if(key === "cat_id") {
      //   return info[key] ? (info[key] || "").split(",") : [];
      // }
      return info[key]
    },
    // 初始化http请求
    async searchList() {
      if (
        (this.parmValue.start_date !== '' && this.parmValue.end_date === '') ||
        (this.parmValue.start_date === '' && this.parmValue.end_date !== '')
      ) {
        this.$message.warning('时间区间不完整！')
        return
      }
      // return;
      this.loading = true
      const res = await asyncRequest.reportchangeloglist({
        ...this.parmValue,
        needRela: true
      })
      console.log(res)
      if (res && res.code === 0 && res.data) {
        this.tableData = res.data.list
        this.pageInfo.total = Number(res.data.count)
      } else if (res && res.code >= 100 && res.code <= 104) {
        await this.logout()
      } else {
        this.tableData = []
        this.pageInfo.total = 0
        this.$message.warning(res.message)
      }
      this.loading = false
    },

    // 重置
    restSearch() {
      this.parmValue = {
        creater: '', // 采购维护人
        supplier_name: '', // 供应商名称
        start_date: '', // 新建起始时间
        end_date: '', // 新建结束时间
        page: 1, // 页码
        size: 15 // 每页显示条数
      }
      // 表格 - 分页
      this.pageInfo = {
        size: 15,
        curr: 1,
        total: 0
      }
      this.searchList()
    },

    // 时间函数
    async time(e) {
      this.parmValue.start_date = e.startTime || ''
      this.parmValue.end_date = e.endTime || ''
      if (
        (this.parmValue.start_date !== '' && this.parmValue.end_date === '') ||
        (this.parmValue.start_date === '' && this.parmValue.end_date !== '')
      ) {
        this.$message.warning('时间区间不完整！')
        return
      }
      this.pageInfo.curr = 1
      this.parmValue.page = 1
      await this.searchList()
    },

    // 选中触发函数
    selection_change(e) {
      const { list } = e
      // 选中的数组集合
      this.changeList = list.length > 0 ? JSON.parse(JSON.stringify(list)) : []
    },
    // 导出文件
    async download() {
      // if(this.changeList.length<=0){
      //   this.$message.warning("请选择有效数据")
      //   return;
      // }
      const start_date = new Date(this.parmValue.start_date).valueOf()
      const end_date = new Date(this.parmValue.end_date).valueOf()
      const flag = end_date - start_date > 30 * 24 * 60 * 60 * 1000
      if (this.parmValue.start_date != '' && this.parmValue.end_date != '') {
        if (flag) {
          this.$message.warning('导出文件的时间区间不能超过30天')
          return
        }
      } else {
        this.$message.warning('请选择导出文件的时间区间')
        return
      }
      const model = JSON.parse(JSON.stringify(this.parmValue))
      // model.is_export = 1;
      if (!this.loading) {
        this.loading = true
        const httpType = `aplication/zip`
        axios({
          method: 'post',
          url: this.fileUrl + 'admin/r_reportchangelogeexport',
          responseType: 'blob',
          data: {
            ...model,
            needRela: true
          },
          headers: {
            // 'Content-Type': 'multipart/form-data',
            // Accept: "application/vnd.ms-excel"
            Accept: httpType
          }
        })
          .then((res) => {
            // console.log(res)
            // console.log(this.fileUrl)
            // return;
            if (res && res.status == 200 && res.data) {
              const url = window.URL.createObjectURL(
                new Blob([res.data], {
                  // type: "application/vnd.openxmlformats-officedocument.spreadsheetml.sheet;charset=utf-8",
                  type: httpType
                })
              )
              const link = document.createElement('a')
              link.style.display = 'none'
              link.href = url
              const excelName = this.getCompanyWithCode(this.currentCompany).name + '-产品修改报表.zip'
              link.setAttribute('download', excelName)
              document.body.appendChild(link)
              link.click()
              link.remove()
              window.URL.revokeObjectURL(url) // 释放掉blob对象
              this.$message.success(`导出成功！`)
              setTimeout(() => {
                this.loading = false
              }, 500)
            } else {
              this.$message.error(res.data.message)
              setTimeout(() => {
                this.loading = false
              }, 500)
            }
          })
          .catch((error) => {
            console.log(error)
            this.loading = false
          })
      }
    }
  }
}
</script>
   <style lang="scss" scoped>
.purchaseOrder {
  // text-align: right;
}
/deep/ .el-dialog {
  width: 80%;
  // height: 50vh;
  min-width: 800px;
  min-height: 500px;
}
</style>

